<template>
  <div>
    <h1>Sala de Chat de {{ user.name }}</h1>

    <!-- Mensajes -->

    <div
      :class="newMessage.user.name != userSend ? classLeft : classRight"
      v-for="message in messages"
      :key="message.id"
    >
      <img
        src="https://bootstrapious.com/i/snippets/sn-chat/avatar.svg"
        alt="user"
        width="50"
        class="rounded-circle"
      />
      <div class="media-body ml-3">
        <div class="bg-success rounded py-2 px-3 mb-2">
          <p class="text-small mb-0 text-white">
            {{ message.body }}
          </p>
        </div>
        <p class="small text-muted">{{ message.date | formatDate }}</p>
      </div>
    </div>

    <!-- Formulario de envío -->
    <form @submit.prevent="sendMessage" class="">
      <input type="text" v-model="messageText" class="form-control" /><br />
      <button class="btn btn-primary" type="submit">Enviar</button>
    </form>
  </div>
</template>
 
<script>
export default {
  name: "ChatRoom",
  props: {
    user: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      messages: [], // Mensajes en la sala de chat
      messageText: "", // Texto del mensaje a enviar
      infoSocket: null,
      newMessage: {},
      classLeft: "media d-flex align-items-center justify-content-start",
      classRight: "media d-flex align-items-center justify-content-end",
      userSend: null,
    };
  },
  sockets: {
    connect: function () {
      console.log("socket connected");
    },
    userconnected: function () {
      // console.log(dataSocket);
    },
    left: function (data) {
      console.log(data);
    },
    message: function (data) {
      console.log(data.message);
      this.messages.push(data.message);

      this.userSend = data.user.name;
    },
    user_send: function () {},
  },
  mounted() {
    this.$socket.emit("join", this.user);
  },
  methods: {
    // Envía el mensaje al servidor y lo añade a la lista de mensajes localmente.
    sendMessage() {
      this.newMessage = {
        body: this.messageText,
        date: new Date(),
        type: "msg",
        user: this.user,
      };
      // Crea el objeto del mensaje a enviar.
      //   this.socket.$emit("send-message", message); // Emite un evento para que el servidor reciba el mensaje.
      this.$socket.emit("message", {
        message: this.newMessage,
        user: this.user,
      });

      this.messages = [...this.messages, this.newMessage]; // Añade el mensaje a la lista localmente.

      this.messageText = ""; // Limpia el campo de texto del formulario para un nuevo envío.
    },
  },
  watch: {},
};
</script>